image: gcc

cache:
  paths:
    - "*/*.o"

stages:
  - build
  - test
  - quality
  - docs

build:
  stage: build
  before_script:
    - apt update && apt upgrade -y
    - apt -y install make autoconf
  script:
    - make
  artifacts:
    paths:
      - sgv

lint:
  stage: quality
  before_script:
    - apt update && apt upgrade -y
    - apt -y install make autoconf splint
  script:
    - make lint

test:
  stage: test
  script:
    - make test

docs:
  stage: docs
  only:
    - master
  before_script:
    - apt update && apt upgrade -y
    - apt -y install make autoconf doxygen
  script:
    - make doc
  artifacts:
    paths:
      - docs/html
